package tea

class SubArray[A](private val array:Array[A], private val start:Int, private val end:Int) extends IndexedSeq[A] {
  require (0 <= start && start <= end && end <= array.size)
  override def hashCode = {
    var sum = 0
    var i = start
    while (i < end) {
      sum = (sum * 29 + array(i).hashCode)
      i += 1
    }
    sum
  }
  override def equals(_that:Any) : Boolean = {
    _that match {
      case that : SubArray[_] =>
        if (this.length == that.length) {
          var i = this.start
          var j = that.start
          while (i < this.end) {
            if (!(this.array(i) equals that.array(j)))
              return false
            i += 1
            j += 1
          }
          true
        }
        else
          false
      case _ => false
    }
  }
  override def length = end-start
  override def apply(i:Int) = {
    assume (i >= 0 && i < length)
    array(start+i)
  }
  def subArray(i:Int, j:Int) = {
    require (i <= j && start+j <= end)
    new SubArray(array, start+i, start+j)
  }
  override def toString = {
    val buf = new StringBuilder
    buf += '['
    var i = start
    while (i<end) {
      if (i > start) buf += ','
      buf.append(array(i).toString)
      i += 1
    }
    buf += ']'
    buf.toString
  }
}